#ifndef __KYEE_TRACE_H__
#define __KYEE_TRACE_H__
#if defined(__aarch64__)
#define KYEE_TRACE_ERROR  1
#define KYEE_TRACE_INFO   2
#define KYEE_TRACE_DEBUG  3
#define KYEE_TRACE_FLOW   4

#define __KYEE_PRINTFLIKE(__fmt, __varargs) __attribute__\
	((__format__(__printf__, __fmt, __varargs)))

void _kyee_dprintf(const char *function, int line, int level,
	      const char *fmt, ...) __KYEE_PRINTFLIKE(4, 5);

#define kyee_dprintf(level, x...) do { \
		_kyee_dprintf(__func__, __LINE__, level, \
				 x); \
	} while (0)

#define KYEE_EMSG(fmt, ...)   kyee_dprintf(KYEE_TRACE_ERROR, fmt, ##__VA_ARGS__)
#define KYEE_IMSG(fmt, ...)   kyee_dprintf(KYEE_TRACE_INFO, fmt, ##__VA_ARGS__)
#define KYEE_DMSG(fmt, ...)   kyee_dprintf(KYEE_TRACE_DEBUG, fmt, ##__VA_ARGS__)
#define KYEE_FMSG(fmt, ...)   kyee_dprintf(KYEE_TRACE_FLOW, fmt, ##__VA_ARGS__)
#endif
#endif

